
// const app = getApp<IAppOption>();
import MyValidator from "../../utils/myValidator";

let validatorInstance: MyValidator;
Component({
  /**
   * 组件的属性列表
   */
  options: {
    addGlobalClass:true,
    multipleSlots: true // 在组件定义时的选项中启用多slot支持
  },
  properties: {
    delivery:{
      type: Object,
      value: {},
      // observer: function (newVal, oldVal, changedPath) {
      //   // 属性被改变时执行的函数（可选），也可以写成在methods段中定义的方法名字符串
      //   // 通常 newVal 就是新设置的数据， oldVal 是旧数据
      //   console.log(newVal,oldVal,changedPath);
      //
      // }
    },
    doccode:{
      type: String,
      value: ''
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    deliveryMethods: ['到店自提-', '配送到家-'],
    isShowPicker:false,
    deliveryMethod: '到店自提-',
    transCosts: 0
  },
  lifetimes:{
    ready(){
      let deliveryMethods = wx.globalData.settings.freeList;
      console.log('配送方式列表。。。',deliveryMethods);
      this.setData({
        deliveryMethods: deliveryMethods,
        deliveryMethod: deliveryMethods[0].FreeName,
        // isRequiredAddress:deliveryMethods[0].isRequiredAddress
      })
      // console.log('获取默认配送列表');
      // if (this.data.doccode){
      //
      // }
      // else{
      //
      // }
      if (!this.data.doccode){
        this.triggerEvent('getDeliveryMethod',{
          deliveryMethod: deliveryMethods[0],
          freeId:deliveryMethods[0].FreeId,
          index:0
        })
      }

      validatorInstance = new MyValidator({
        rules: {
          transCosts: {
            required: true,
            number: true
          }
        },
        messages: {
          transCosts: {
            required: '请输入配送费',
            number: '配送费必须为数字'
          }
        },
        multiCheck:true
      },this);
    }
  },
  observers: {
    'delivery': function(val) {
      console.log('监听配送方式delivery',val,this.data.delivery)
      if (JSON.stringify(val)!='{}'){
        let delivery = this.data.delivery;
        this.setData({
          deliveryMethod: delivery.freeName,
          freeId: delivery.freeId,
          transCosts: delivery.transCosts,
          isRequiredAddress:delivery.isRequiredAddress
        })
      }

    }
  },
  /**
   * 组件的方法列表
   */
  methods: {
    showPicker(){
      this.setData({isShowPicker:true});
    },
    onPickerClose(){
      this.setData({isShowPicker:false});
    },
    onPickerConfirm(event:any) {
      const { value, index } = event.detail;
      console.log(value,index);
      this.setData({
        deliveryMethod: value.FreeName,
        isRequiredAddress:value.isRequiredAddress
      })
      this.onPickerClose();
      this.triggerEvent('getDeliveryMethod',{
        deliveryMethod: value,
        freeId:value.FreeId,
        index
      })
    },

    onPickerCancel() {
      console.log('取消');
      this.onPickerClose();
    },

    checkTransCosts(e:any){
      let { value } = e.detail
      console.log(e);
      validatorInstance.checkField('transCosts',value);
      this.setData({
        transCosts:value.trim()
      })
    },
    checkFields(){
      return validatorInstance.checkAllData()
    },
  }
})
